require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
      module AllFromOrganizationalUnitCast
        # @deprecated All From OU will not be used in the new authorization (v4).
        class AllFromOrganizationalUnitCastSetAttributes < UU::OS::REST::DTO

          # @see AllFromOrganizationalUnitCast#set_attributes
          attr_accessor :casted_subject_uri

          # @see AllFromOrganizationalUnitCast#set_attributes
          attr_accessor :level

          # @see AllFromOrganizationalUnitCast#set_attributes
          attr_accessor :date_to

          # @see AllFromOrganizationalUnitCast#set_attributes
          attr_accessor :state

          def casted_subject_uri 
            attributes[:castedSubjectUri]
          end

          def casted_subject_uri=(val) 
            if val
              attributes[:castedSubjectUri] = UU::OS::UESURI.new(val)
            else
              attributes[:castedSubjectUri] = nil
            end
          end

          def level 
            attributes[:level]
          end

          def level=(val) 
            attributes[:level] = val
          end

          def date_to 
            attributes[:dateTo]
          end

          def date_to=(val) 
            attributes[:dateTo] = val
          end

          def state 
            attributes[:state]
          end

          def state=(val) 
            attributes[:state] = val
          end

        end
      end

    end
  
end
