require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module Artifact
      # @see Artifact#move
      class ArtifactMove < UU::OS::REST::DTO

        # @see Artifact#move
        attr_accessor :keep_shortcut

        # @see Artifact#move
        attr_accessor :location_uri

        def keep_shortcut 
          attributes[:keepShortcut]
        end

        def keep_shortcut=(val) 
          attributes[:keepShortcut] = val
        end

        def location_uri 
          attributes[:locationUri]
        end

        def location_uri=(val) 
          if val
            attributes[:locationUri] = UU::OS::UESURI.new(val)
          else
            attributes[:locationUri] = nil
          end
        end
      end
    end
  end
end