require 'uu/os/rest/dto'
require 'uu/os/uesuri'

module UU
  module OS
    module MetaGroup
      class MetaGroupCopy < UU::OS::REST::DTO

        # @see MetaGroup#copy
        attr_accessor :location_uri

        # @see MetaGroup#copy
        attr_accessor :name

        # @see MetaGroup#copy
        attr_accessor :code

        # @see MetaGroup#copy
        attr_accessor :description

        # @see MetaGroup#copy
        attr_accessor :competent_role_uri

        # @see MetaGroup#copy
        attr_accessor :security_level

        # @see MetaGroup#copy
        attr_accessor :icon_uri

        # @see MetaGroup#copy
        attr_accessor :copy_sheets

        # @see MetaGroup#copy
        attr_accessor :copy_lifecycle

        # @see MetaGroup#copy
        attr_accessor :copy_attachments

        # @see MetaGroup#copy
        attr_accessor :copy_sheet_templates

        # @see MetaGroup#copy
        attr_accessor :default_name

        # @see MetaGroup#copy
        attr_accessor :default_code

        # @see MetaGroup#copy
        attr_accessor :default_security_level

        # @see MetaGroup#copy
        attr_accessor :default_icon_uri

        # @see MetaGroup#copy
        attr_accessor :default_searchable_in_territory

        # @deprecated Input value is ignored, nil is always assumed.
        attr_accessor :default_artifact_type

        # Indicates whether the primarily displayed content of the meta group is component content.
        attr_accessor :component_content

        # @see MetaGroup#copy
        attr_accessor :default_component_content
        # @deprecated Always returns nil.
        def default_artifact_type
          nil
        end

        # @deprecated Input value is ignored, nil is always assumed.
        def default_artifact_type=(val)
        end

        def location_uri
          attributes[:locationUri]
        end

        def location_uri=(val)
          if val
            attributes[:locationUri] = UU::OS::UESURI.new(val)
          else
            attributes[:locationUri] = nil
          end
        end

        def name
          attributes[:name]
        end

        def name=(val)
          attributes[:name] = val
        end

        def code
          attributes[:code]
        end

        def code=(val)
          attributes[:code] = val
        end

        def description
          attributes[:description]
        end

        def description=(val)
          attributes[:description] = val
        end

        def competent_role_uri
          attributes[:competentRoleUri]
        end

        def competent_role_uri=(val)
          if val
            attributes[:competentRoleUri] = UU::OS::UESURI.new(val)
          else
            attributes[:competentRoleUri] = nil
          end
        end

        def security_level
          attributes[:securityLevel]
        end

        def security_level=(val)
          attributes[:securityLevel] = val
        end

        def icon_uri
          attributes[:iconUri]
        end

        def icon_uri=(val)
          if val
            attributes[:iconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:iconUri] = nil
          end
        end

        def copy_sheets
          attributes[:copySheets]
        end

        def copy_sheets=(val)
          attributes[:copySheets] = val
        end

        def copy_lifecycle
          attributes[:copyLifecycle]
        end

        def copy_lifecycle=(val)
          attributes[:copyLifecycle] = val
        end

        def copy_attachments
          attributes[:copyAttachments]
        end

        def copy_attachments=(val)
          attributes[:copyAttachments] = val
        end

        def copy_sheet_templates
          attributes[:copySheetTemplates]
        end

        def copy_sheet_templates=(val)
          attributes[:copySheetTemplates] = val
        end

        def default_name
          attributes[:defaultName]
        end

        def default_name=(val)
          attributes[:defaultName] = val
        end

        def default_code
          attributes[:defaultCode]
        end

        def default_code=(val)
          attributes[:defaultCode] = val
        end

        def default_security_level
          attributes[:defaultSecurityLevel]
        end

        def default_security_level=(val)
          attributes[:defaultSecurityLevel] = val
        end

        def default_icon_uri
          attributes[:defaultIconUri]
        end

        def default_icon_uri=(val)
          if val
            attributes[:defaultIconUri] = UU::OS::UESURI.new(val)
          else
            attributes[:defaultIconUri] = nil
          end
        end

        def default_searchable_in_territory
          attributes[:defaultSearchableInTerritory]
        end

        def default_searchable_in_territory=(val)
          attributes[:defaultSearchableInTerritory] = val
        end

        def component_content
          attributes[:componentContent]
        end

        def component_content=(val)
          attributes[:componentContent] = val
        end

        def default_component_content
          attributes[:defaultComponentContent]
        end

        def default_component_content=(val)
          attributes[:defaultComponentContent] = val
        end

      end
    end

  end

end
