module UU
  module OS
    
      module Script

        # Set of common script options.
        # @deprecated Use {UU::OS::Macro::MacroExecOptions} instead.
        class ScriptExecOptions

          # Type of script.
          SCRIPT_TYPE = 'scriptType'

          # Scripting language version.
          LANG_VERSION = 'langVersion'

          # Names for script dedication to queue.
          EXEC_GROUPS = 'execGroups'

          # Crontab-phrase time for script execution window. 
          EXEC_WINDOW = 'execWindow'

          # The limit of automatic script re-launching.
          MAX_REFIRE_COUNT = 'maxRefireCount'

          # Flag indicating whether the script should be recovered after an exception.
          SCRIPT_RECOVERABLE = 'recoverable'

          # Flag indicating whether the script should report progress via workflow.
          WF_MON_ENABLED = 'wfMonitorEnabled'

          # UESURI of activity which should be used to report progress.
          WF_MON_ACT_URI = 'wfMonitorActivity'

          # UESURI of activity definition which should be used to report progress.
          WF_MON_ACT_TMPL_URI = 'wfMonitorActivityTemplate'

          # Definition of transaction propagation behavior.
          TX_PROPAGATION = 'txPropagation'

        end

      end
    end

end
